#!/bin/sh
#                                                          -*- fundamental -*-
# cmad.cgi
#	Copyright 2002 (C) SAITOH-Ely-Yasuhiro.
#	All rights reserved.
#
VERSION=@VER@

#
# Set path of sendmail
#
SENDMAIL=@SENDMAIL@

#
# Set local environment.
#
DRIVER=@DRIVER@
DOMAIN=@DOMAIN@
ORGDOM=@DOMAIN@
MSPOOL=@MSPOOL@
PATH=@PATH@
AWK=@AWK@
GREP=@GREP@

export DRIVER DOMAIN ORGDOM MSPOOL PATH
umask 022

# Get My PID.
MYPID=$$
export MYPID

#
# Set work file.
#
TEMP=/tmp/TEMP.$$
MAIL=/tmp/MAIL.$$
trap "rm -f $TEMP $MAIL; exit 0" 0 1 2 3 15

#
# start
#

echo "Content-type: text/html

<html>
<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">
<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;CHARSET=utf-8\">
<body bgcolor="#FFFFFF" fgcolor="#000000">"

#
# Check login parameter
#
# get information
sed -e 's/^-/ /' -e 's/\"//g' -e 's/name=//' | \
    tr -d "\n" | tr -d "\r" | tr " " "\n"  > $TEMP

set `$GREP "COMMAND:" $TEMP | sed -e 's/COMMAND://'` x
COMMAND=$1

set `$GREP "ML:" $TEMP | sed -e 's/ML://'` x
set `echo $1 | sed -e 's/@/ /'` x x
ML=$1
DOM=$2

set `$GREP "ADDRESS:" $TEMP | sed -e 's/ADDRESS://'` x
ADDRESS=$1

set `$GREP "PIN:" $TEMP | sed -e 's/PIN://'` x
PIN=$1

#
# In case of login, parameters check.
#
if [ "$COMMAND" = "LOGIN" ]
then
	ERROR=0
	if [ -d $DRIVER/$ML ] 
	then

		# Set default value.
		. $DRIVER/config.default

		# Set ML value.
		if [ -f $DRIVER/$ML/config.$ML ]
		then
			. $DRIVER/$ML/config.$ML
		fi

		# Check domain name.
		if [ "$GENERICFROM" ]
		then
		        DOMAIN=$GENERICFROM
		fi

		echo $DOM | $GREP -i $DOMAIN >/dev/null 2>&1
		if [ $? -ne 0 ]
		then
			ERROR=1
		fi

		# Member list
		LIST=$DRIVER/$ML/$ML-member

		# Deliver list
		DELV=$DRIVER/$ML/$ML-list

		# List of Post Only
		POST=$DRIVER/$ML/$ML-postonly

		ADLIST=$DRIVER/$ML/$ML-admins
		ADMIN=`egrep -i \<$ADDRESS\>$ $ADLIST`

		if [ "$ADMIN" ]
		then
			set $ADMIN . .
			echo $1 | $GREP $PIN >/dev/null 2>&1
			if [ $? -ne 0 ]
			then
				ERROR=2
			fi
		else
			ERROR=3
		fi
	else
		ERROR=4
	fi

	if [ $ERROR -ne 0 ]
	then
		echo "<p>"
		echo "Loginできません (エラーコード: $ERROR)<br>"
		echo "ブラウザの「戻る」でLogin画面に戻ってください。<br>"
		echo "</body>"
		echo "</html>"

		exit 0
	fi

	COMMAND=START
fi

# Set default value.
. $DRIVER/config.default

# Set ML value.
if [ -f $DRIVER/$ML/config.$ML ]
then
	. $DRIVER/$ML/config.$ML
fi

# Check domain name.
if [ "$GENERICFROM" ]
then
        DOMAIN=$GENERICFROM
fi

# Member list
LIST=$DRIVER/$ML/$ML-member

# Deliver list
DELV=$DRIVER/$ML/$ML-list

# List of Post Only
POST=$DRIVER/$ML/$ML-postonly

# Make unix-from address.
if [ ! "$UNIXFROM" ]
then
	UNIXFROM=$ML-request@$DOM
fi


trap "rm -f $TEMP $MAIL; exit 0" 0 1 2 3 15

#
# write title
#
echo "<p>
<font size='+2' color='#008888'>
$ML ML admin page<br>
<hr>
</font>
<font size='-1' color='#008888'>
Administrator:</font> $ADDRESS<br>
<hr>"



#
# parameter get
#
set `$GREP "NUMBER:" $TEMP | \
	sed -e 's/NUMBER://' -e 's/-A//' -e 's/-P:.*//'` x
NUMBER=$1

POSTADINFO=0
$GREP "NUMBER:" $TEMP | $GREP '[0-9][0-9][0-9][0-9]-P:' >/dev/null 2>&1
if [ $? -eq 0 ]
then
	set `$GREP "NUMBER:" $TEMP | \
		sed -e 's/NUMBER://' -e 's/[0-9][0-9][0-9][0-9]-P://'` x
	POSTAD=$1
	POSTADINFO=1
fi
set `$GREP "OPT:" $TEMP | sed -e 's/OPT://'` x
OPT=$1

#
# Syntax check and write message.
#
ACTION=0
case $COMMAND in
APPEND)
	if [ "$OPT" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "登録するアドレスが入力されていません。<br>"
		echo "</font>"
		ACTION=1
	else
		echo "<font color=#ff0000>$OPT</font>"
		echo "<font color=#0000ff>を新規に追加します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
STOP)
	if [ "$NUMBER" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "停止する送信用アドレスが選択されていません。<br>"
		echo "</font>"
		ACTION=1
	elif [ $POSTADINFO -eq 1 ]
	then
		echo "<font color=#ff0000>"
		echo "投稿用アドレスが選択されています。<br>"
		echo "</font>"
		ACTION=1
	else
		AD=`egrep ^$NUMBER $LIST | \
			sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' | \
			awk '{ print $3 }'`

		echo "<font color=#ff0000>$AD</font>"
		echo "<font color=#0000ff>への配送を停止します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
SEND)
	if [ "$NUMBER" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "配送する送信用アドレスが選択されていません。<br>"
		echo "</font>"
		ACTION=1
	elif [ $POSTADINFO -eq 1 ]
	then
		echo "<font color=#ff0000>"
		echo "投稿用アドレスが選択されています。<br>"
		echo "</font>"
		ACTION=1
	else
		AD=`egrep ^$NUMBER $LIST | \
			sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' | \
			awk '{ print $3 }'`
		echo "<font color=#ff0000>$AD</font>"
		echo "<font color=#0000ff>への配送を開始します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
DELETE)
	if [ "$NUMBER" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "削除する投稿用アドレスが選択されていません。<br>"
		echo "</font>"
		ACTION=1
	elif [ $POSTADINFO -eq 1 ]
	then
		echo "<font color=#ff0000>"
		echo "投稿用アドレスが選択されています。<br>"
		echo "</font>"
		ACTION=1
	else
		AD=`egrep ^$NUMBER $LIST | \
			sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' | \
			awk '{ print $3 }'`
		echo "<font color=#ff0000>$AD</font>"
		echo "<font color=#0000ff>をMLから削除します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
ADDRESS)

	if [ "$NUMBER" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "変更する送信用アドレスが選択されていません。<br>"
		echo "</font>"
		ACTION=1
	elif [ $POSTADINFO -eq 1 ]
	then
		echo "<font color=#ff0000>"
		echo "投稿用アドレスが選択されています。<br>"
		echo "</font>"
		ACTION=1
	fi
	if [ "$OPT" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "変更後の送信用アドレスが入力されていません。<br>"
		echo "</font>"
		ACTION=1
	fi
	if [ $ACTION -ne 1 ]
	then
		AD=`egrep ^$NUMBER $LIST | \
			sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' | \
			awk '{ print $3 }'`

		echo "<font color=#0000ff>"
		echo "送信先を"
		echo "</font>"
		echo "<font color=#ff8888>$AD</font>"
		echo "<font color=#0000ff>"
		echo "から"
		echo "</font>"
		echo "<font color=#ff0000>$OPT"
		echo "</font>"
		echo "<font color=#0000ff>"
		echo "へ変更します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
POSTADD)
	if [ "$NUMBER" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "配送用のアドレスが選択されていません。<br>"
		echo "</font>"
		ACTION=1
	elif [ $POSTADINFO -eq 1 ]
	then
		echo "<font color=#ff0000>"
		echo "投稿用アドレスが選択されています。<br>"
		echo "</font>"
		ACTION=1
	fi
	if [ "$OPT" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "追加する投稿用アドレスが入力されていません。<br>"
		echo "</font>"
		ACTION=1
	fi
	if [ $ACTION -ne 1 ]
	then
		AD=`egrep ^$NUMBER $LIST | \
			sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' | \
			awk '{ print $3 }'`

		echo "<font color=#ff8888>$AD</font>"
		echo "<font color=#0000ff>"
		echo "の投稿用アドレスに"
		echo "</font>"
		echo "<font color=#ff0000>$OPT"
		echo "</font>"
		echo "<font color=#0000ff>"
		echo "を追加します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
POSTDEL)
	if [ "$NUMBER" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "削除する投稿アドレスが選択されていません。<br>"
		echo "</font>"
		ACTION=1
	elif [ $POSTADINFO -eq 0 ]
	then
		echo "<font color=#ff0000>"
		echo "配送用アドレスが選択されています。<br>"
		echo "</font>"
		ACTION=1
	else
		AD=`egrep ^$NUMBER $LIST | \
			sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' | \
			awk '{ print $3 }'`

		OPT=$POSTAD
		echo "<font color=#ff8888>$AD</font>"
		echo "<font color=#0000ff>"
		echo "の投稿用アドレスから"
		echo "</font>"
		echo "<font color=#ff0000>$OPT"
		echo "</font>"
		echo "<font color=#0000ff>"
		echo "を削除します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
DGST)
	if [ "$NUMBER" = "x" ]
	then
		echo "<font color=#ff0000>"
		echo "まとめ送りにする送信用アドレスが選択されていません。<br>"
		echo "</font>"
		ACTION=1
	elif [ $POSTADINFO -eq 1 ]
	then
		echo "<font color=#ff0000>"
		echo "投稿用アドレスが選択されています。<br>"
		echo "</font>"
		ACTION=1
	else
		AD=`egrep ^$NUMBER $LIST | \
			sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' | \
			awk '{ print $3 }'`
		echo "<font color=#ff0000>$AD</font>"
		echo "<font color-#0000ff>へはまとめ送りで送信します。<br>"
		echo "</font>"
		ACTION=2
	fi
	;;
EXEC:APPEND|EXEC:STOP|EXEC:SEND|EXEC:DELETE|\
EXEC:ADDRESS|EXEC:DGST|EXEC:POSTADD|EXEC:POSTDEL)
	ACTION=3
	;;
START)
	ACTION=4
	;;

esac

#
# Write button
#

case $ACTION in
1)
	echo "<table><tr><td>
	<FORM ENCTYPE='multipart/form-data'
		ACTION='/cgi-bin/cmad.cgi' METHOD=POST>
	<INPUT TYPE='submit' VALUE='了解'><br>
	<input type='hidden' name='COMMAND:' value='START'><br>
	<input type='hidden' name='ML:' value=\"$ML@$DOM\"><br>
	<input type='hidden' name='ADDRESS:' value=$ADDRESS><br>
	<input type='hidden' name='PIN:' value=$PIN><br>

	</FORM>
	</tr></table>
	</body>
	</html>"

	exit 0
	;;
2)
	echo "<table><tr><td>
	<FORM ENCTYPE='multipart/form-data'
		ACTION='/cgi-bin/cmad.cgi' METHOD=POST>
	<input type='radio' name='COMMAND:' value=EXEC:$COMMAND>実行する<br>
	<input type='radio' name='COMMAND:' value=START checked>キャンセル<br>
	<INPUT TYPE='submit' VALUE='確認'><br>
	<input type='hidden' name='NUMBER:' value='$NUMBER'><br>
	<input type='hidden' name='OPT:' value='$OPT'><br>
	<input type='hidden' name='ML:' value=\"$ML@$DOM\"><br>
	<input type='hidden' name='ADDRESS:' value=$ADDRESS><br>
	<input type='hidden' name='PIN:' value=$PIN><br>
	</FORM>
	</tr></table>
	</body>
	</html>"

	exit 0
	;;
3)
	echo "To: ${ML}-control@$DOM" >  $MAIL
	echo "From: $ADDRESS"         >> $MAIL
	echo "Subject: admincmd"      >> $MAIL
	echo ""                       >> $MAIL
	echo "$PIN"                   >> $MAIL

	case $COMMAND in
	EXEC:APPEND)
		echo "admincmd append $OPT" >> $MAIL
		;;
	EXEC:STOP)
		echo "admincmd stop $NUMBER" >> $MAIL
		;;
	EXEC:SEND)
		echo "admincmd send $NUMBER" >> $MAIL
		;;
	EXEC:DELETE)
		echo "admincmd delete $NUMBER" >> $MAIL
		;;
	EXEC:ADDRESS)
		echo "admincmd address $NUMBER $OPT" >> $MAIL
		;;
	EXEC:POSTADD)
		echo "admincmd postadd $NUMBER $OPT" >> $MAIL
		;;
	EXEC:POSTDEL)
		echo "admincmd postdel $NUMBER $OPT" >> $MAIL
		;;
	EXEC:DGST)
		echo "admincmd digest $NUMBER" >> $MAIL
		;;
	esac

	$SENDMAIL ${ML}-control@$DOM -f$UNIXFROM < $MAIL
	sleep 2
esac


#
# write member list
#
echo "<TABLE CELLPADDING=3>
<tr><td>
<FORM ENCTYPE='multipart/form-data' ACTION='/cgi-bin/cmad.cgi' METHOD=POST>
<p>
配送中リスト<br>
<select name='NUMBER:' size=10>
"

sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' < $LIST |\
    $GREP "^[0-9][0-9][0-9][0-9] SEND"  | \
    $AWK '{ printf("<option value=%04d-A>%s</option>\n", $1, $3); }' > $TEMP

for i in `$GREP "^[0-9][0-9][0-9][0-9] SEND" $LIST | $AWK '{ print $1 }'`
do
    $GREP $i $POST | sed  -e 's/<//' -e 's/>//' |\
    $AWK '{
	printf("<option value=%04d-P:%s>+%s</option>\n", $1, $2, $2);
     }' >> $TEMP
done

sort $TEMP

echo "</select>
<td><p>
コマンド<br>
<select name='COMMAND:'>
	<option value=APPEND>新規登録</option>
	<option value=STOP>停止</option>
	<option value=DELETE>削除</option>
	<option value=ADDRESS>配送用アドレス変更</option>
	<option value=POSTADD>投稿用アドレス登録</option>
	<option value=POSTDEL>投稿用アドレス削除</option>
	<option value=DGST>まとめ送り</option>
</select>
<p>
(登録および変更の場合)新しいアドレス<br>
<input type=text name=OPT: size=30><br>

<input type='hidden' name='ML:' value=\"$ML@$DOM\"><br>
<input type='hidden' name='ADDRESS:' value=$ADDRESS><br>
<input type='hidden' name='PIN:' value=$PIN><br>

<INPUT TYPE='submit' VALUE='配送中リストの変更'><br>

</FORM>
</tr>
</table>

<hr>
<TABLE CELLPADDING=3>
<tr><td>
<FORM ENCTYPE='multipart/form-data' ACTION='/cgi-bin/cmad.cgi' METHOD=POST>
<p>
停止中リスト<br>
<select name='NUMBER:' size=10>
"

sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' < $LIST |\
    $GREP "^[0-9][0-9][0-9][0-9] STOP"  | \
    $AWK '{ printf("<option value=%04d-A >%s</option>\n", $1, $3); }' > $TEMP

for i in `$GREP "^[0-9][0-9][0-9][0-9] STOP" $LIST | $AWK '{ print $1 }'`
do
    $GREP $i $POST | sed  -e 's/<//' -e 's/>//' |\
    $AWK '{
	printf("<option value=%04d-P:%s>+%s</option>\n", $1, $2, $2);
     }' >> $TEMP
done

sort $TEMP

echo "</select>
<td><p>
コマンド<br>
<select name='COMMAND:'>
	<option value=SEND>配送</option>
	<option value=DELETE>削除</option>
	<option value=ADDRESS>配送用アドレス変更</option>
	<option value=POSTADD>投稿用アドレス追加</option>
	<option value=POSTDEL>投稿用アドレス削除</option>
	<option value=DGST>まとめ送り</option>
</select>
<p>
(アドレス変更の場合のみ)新しいアドレス<br>
<input type=text name=OPT: size=30><br>

<input type='hidden' name='ML:' value=\"$ML@$DOM\"><br>
<input type='hidden' name='ADDRESS:' value=$ADDRESS><br>
<input type='hidden' name='PIN:' value=$PIN><br>

<INPUT TYPE='submit' VALUE='停止中リストの変更'><br>
</FORM>
</tr>
</table>


<hr>
<TABLE CELLPADDING=3>
<tr><td>
<FORM ENCTYPE='multipart/form-data' ACTION='/cgi-bin/cmad.cgi' METHOD=POST>
<p>
まとめ送り中リストの変更<br>
<select name='NUMBER:' size=10>
"

sed -e 's/(//' -e 's/)//' -e 's/<//' -e 's/>//' < $LIST |\
    $GREP "^[0-9][0-9][0-9][0-9] DGST"  | \
    $AWK '{ printf("<option value=%04d-A>%s</option>\n", $1, $3); }' > $TEMP

for i in `$GREP "^[0-9][0-9][0-9][0-9] DGST" $LIST | $AWK '{ print $1 }'`
do
    $GREP $i $POST | sed  -e 's/<//' -e 's/>//' |\
    $AWK '{
	printf("<option value=%04d-P:%s>+%s</option>\n", $1, $2, $2);
     }' >> $TEMP
done

sort $TEMP

echo "</select>
<td><p>
コマンド<br>
<select name='COMMAND:'>
	<option value=SEND>配送</option>
	<option value=STOP>停止</option>
	<option value=DELETE>削除</option>
	<option value=ADDRESS>配送用アドレス変更</option>
	<option value=POSTADD>投稿用アドレス追加</option>
	<option value=POSTDEL>投稿用アドレス削除</option>

</select>
<p>
(アドレス変更の場合のみ)新しいアドレス<br>
<input type=text name=OPT: size=30><br>
</select>

<input type='hidden' name='ML:' value=\"$ML@$DOM\"><br>
<input type='hidden' name='ADDRESS:' value=$ADDRESS><br>
<input type='hidden' name='PIN:' value=$PIN><br>

<INPUT TYPE='submit' VALUE='まとめ送りリストの変更'><br>
</FORM>
</tr>
</table>

<hr>
<TABLE CELLPADDING=3>
<tr><td>
<FORM ENCTYPE='multipart/form-data' ACTION='/cgi-bin/cmad.cgi' METHOD=POST>
<input type='submit' VALUE='最新の情報に更新'><br>
<input type='hidden' name='ML:' value=\"$ML@$DOM\"><br>
<input type='hidden' name='ADDRESS:' value=$ADDRESS><br>
<input type='hidden' name='PIN:' value=$PIN><br>
<input type='hidden' name='COMMAND:' value=\"START\"><br>
</FORM>
</tr>
</table>

"

exit 0
